Unit IAM2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IAM2R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Z :Array of Real;
                var II :Array of Integer; var F0 :Array of Real;
                var F :Array of Real; var A :Array of Real;
                var B :Array of Real; var C :Array of Real;
                var H :Array of Real; var V :Array of Real);

implementation

procedure IAM2R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Z :Array of Real;
                var II :Array of Integer; var F0 :Array of Real;
                var F :Array of Real; var A :Array of Real;
                var B :Array of Real; var C :Array of Real;
                var H :Array of Real; var V :Array of Real);
var
I,I0,I1,I2,IB,IE,IM,J,J0,L,N1,NN,NN1,NN2 :Integer;
A0,B0,FTI,Q,R,R1,T :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280;
begin
A[0] := 0.0;
B[0] := 0.0;
N1  := N - 1;
for I:=1 to N1 do
 begin
  A[I+0] := A[I-1] + (X[I+0] - X[I-1])*(Y[I+0] + Y[I-1])/2.0;
  B[I+0] := B[I-1] + X[I-1]*(A[I+0] - A[I-1]) + IntPower(X[I+0] - X[I-1],2)*
    (Y[I-1] + 2.0*Y[I+0])/6.0;
_10:
 end;
for I:=1 to N do
 begin
  F0[I-1] := X[I-1]*A[I-1] - B[I-1];
_20:
 end;
Q  := A[N-1];
NN  := 2;
II[0] := 1;
II[1] := N;
H[0] := X[N-1] - X[0];
F[0] := 0.0;
F[1] := F0[N-1];
V[0] := 0.0;
V[1] := Q;
_30:
R  := 0.0;
NN1  := NN - 1;
for J:=1 to NN1 do
 begin
  I0  := II[J-1];
  I1  := I0 + 1;
  I2  := II[J+0];
  for I:=I1 to I2 do
   begin
    T  := (X[I-1] - X[I0-1])/H[J-1];
    FTI  := F[J-1]*IntPower(1.0 - T,2)*(1.0 + 2.0*T) + F[J+0]*IntPower(T,2)*(3.0 -
    2.0*T) + H[J-1]*T*(1.0 - T)*(V[J-1]*(1.0 - T) - V[J+0]
    *T);
    R1  := F0[I-1] - FTI;
    if ( R1  <=  R ) 
     then goto _40;
    IM  := I;
    J0  := J + 1;
    R  := R1;
_40:
   end;
 end;
if ( R  =  0.0 ) 
 then goto _240;
for J:=1 to J0 do
 begin
  Z[J-1] := B[J-1];
_50:
 end;
for L:=J0 to NN do
 begin
  J  := -L + NN + J0;
  II[J+0] := II[J-1];
  Z[J+0] := B[J-1];
_60:
 end;
II[J0-1] := IM;
Z[J0-1] := 0.0;
NN  := NN + 1;
_70:
NN1  := NN - 1;
for J:=1 to NN1 do
 begin
  I1  := II[J-1];
  I2  := II[J+0];
  H[J-1] := X[I2-1] - X[I1-1];
  F[J-1] := F0[I1-1];
_80:
 end;
F[NN-1] := F0[N-1];
V[NN-1] := Q;
for J:=2 to NN1 do
 begin
  A[J-1] := H[J-2]/(H[J-2] + H[J-1]);
  B[J-1] := H[J-1]/(H[J-2] + H[J-1]);
  C[J-1] := 3.0*(A[J-1]*(F[J+0]-F[J-1])/H[J-1] + B[J-1]*(F[J-1] -
    F[J-2])/H[J-2]);
_90:
 end;
C[NN-2] := C[NN-2] - A[NN-2]*V[NN-1];
B[1] := 2.0;
if ( NN  =  3 ) 
 then goto _110;
for J:=3 to NN1 do
 begin
  C[J-1] := C[J-1] - C[J-2]*B[J-1]/B[J-2];
  B[J-1] := 2.0 - A[J-2]*B[J-1]/B[J-2];
_100:
 end;
_110:
V[NN-2] := C[NN-2]/B[NN-2];
if ( NN  =  3 ) 
 then goto _130;
NN2  := NN - 2;
for L:=2 to NN2 do
 begin
  J  := NN - L;
  V[J-1] := (C[J-1] - A[J-1]*V[J+0])/B[J-1];
_120:
 end;
_130:
for J:=1 to NN1 do
 begin
  A[J-1] := 12.0*(F[J-1] - F[J+0])/IntPower(H[J-1],3) + 6.0*(V[J-1] + V[J+0]
    )/IntPower(H[J-1],2);
_140:
 end;
for J:=2 to NN1 do
 begin
  B[J-1] := A[J-1] - A[J-2];
_150:
 end;
for J:=2 to NN1 do
 begin
  if ( B[J-1] <  0.0 ) 
   then goto _180;
_160:
 end;
L  := 1;
for J:=2 to NN1 do
 begin
  if ( B[J-1] =  0.0 ) 
   then goto _170;
  L  := L + 1;
  II[L-1] := II[J-1];
  B[L-1] := B[J-1];
_170:
 end;
NN  := L + 1;
II[NN-1] := N;
goto _30;
_180:
T  := 1.0;
for J:=2 to NN1 do
 begin
  if ( B[J-1] >=  0.0 ) 
   then goto _190;
  R  := Z[J-1]/(Z[J-1] - B[J-1]);
  if ( R  <  T ) 
   then T  := R;
_190:
 end;
L  := 1;
for J:=2 to NN1 do
 begin
  if ( B[J-1] ) < 0
   then goto _200
   else if ( B[J-1] ) > 0
         then goto _220
         else goto _210;
_200:
  R  := Z[J-1]/(Z[J-1] - B[J-1]);
  if ( R  =  T ) 
   then goto _230;
  goto _220;
_210:
  if ( Z[J-1] =  0.0 ) 
   then goto _230;
_220:
  L  := L + 1;
  II[L-1] := II[J-1];
  Z[L-1] := (1.0 - T)*Z[J-1] + T*B[J-1];
_230:
 end;
NN  := L + 1;
II[NN-1] := N;
goto _70;
_240:
Z[N-1] := 6.0*(F[NN-2] - F[NN-1])/IntPower(H[NN-2],2) + (2.0*V[NN-2] + 4.0*
    V[NN-1])/H[NN-2];
for J0:=2 to NN do
 begin
  J  := NN - J0 + 1;
  I1  := II[J-1];
  I2  := II[J+0];
  Z[I1-1] := 6.0*(F[J+0] - F[J-1])/IntPower(H[J-1],2) - (4.0*V[J-1] + 2.0*
    V[J+0])/H[J-1];
  IB  := I1 + 1;
  IE  := I2 - 1;
  for I:=IB to IE do
   begin
    A0  := (Z[I2-1] - Z[I1-1])/(X[I2-1] - X[I1-1]);
    B0  := (Z[I1-1]*X[I2-1] - Z[I2-1]*X[I1-1])/(X[I2-1] - X[I1-1]);
    Z[I-1] := A0*X[I-1] + B0;
_250:
   end;
_260:
 end;
if ( NN  =  N ) 
 then goto _280;
NN1  := NN + 1;
for I:=NN1 to N do
 begin
  II[I-1] := 0;
_270:
 end;
_280:
end;

end.
